package kr.as3.utils
{
	/**
	 * HangulUtil
	 *
	 * author: Yun Jinsang (a.k.a. Wooyaggo, http://www.as3.kr, victim4 at gmail.com)
	 * created: Mar 22, 2010
	 *
	 */
	
	public class HangulUtil
	{
		static private const LIST_CHO: String = "ㄱㄲㄴㄷㄸㄹㅁㅂㅃㅅㅆㅇㅈㅉㅊㅋㅌㅍㅎ";
		static private const LIST_JUNG: String = "ㅏㅐㅑㅒㅓㅔㅕㅖㅗㅘㅙㅚㅛㅜㅝㅞㅟㅠㅡㅢㅣ";
		static private const LIST_JONG: String = " ㄱㄲㄳㄴㄵㄶㄷㄹㄺㄻㄼㄽㄾㄿㅀㅁㅂㅄㅅㅆㅇㅈㅊㅋㅌㅍㅎ";
		
		static private const CODE_BEGIN: int = 0xAC00;
		static private const CODE_LAST: int = 0xD79F;
		
		static public function merge( $cho: String, $jung: String, $jong: String = "" ): String
		{
			var choCode: int = LIST_CHO.indexOf( $cho );
			var jungCode: int = LIST_JUNG.indexOf( $jung );
			var jongCode: int = LIST_JONG.indexOf( $jong );
			
			var strCode: int = CODE_BEGIN + ( choCode * 21 + jungCode ) * 28 + jongCode;
			var str: String = String.fromCharCode( strCode );
			
			return str;
		}
		
		static public function divide( $str: String ): Array
		{
			var cho: int;
			var jung: int;
			var jong: int;
			
			var code: int = $str.charCodeAt( 0 );
			
			if( code < CODE_BEGIN )
				return null;
			
			if( code > CODE_LAST )
				return null;
			
			code = code - CODE_BEGIN;
			cho = code / ( 21 * 28 );
			
			code = code % ( 21 * 28 );
			jung = code / 28;
			
			code = code % 28;
			jong = code;
			
			var arr: Array = [ LIST_CHO.charAt( cho ), LIST_JUNG.charAt( jung ), LIST_JONG.charAt( jong ) ];
			
			return arr;
		}
		
		static public function addSuffix( $text: String, $type1: String = "을", $type2: String = "를" ): String
		{
			var str: String;
			
			if( divide( $text.charAt( $text.length - 1 ) )[ 2 ] == 0 )
				str = $text + $type2;
			else
				str = $text + $type1;
			
			return str;
		}
	}
}