package kr.as3.utils
{
	/**
	 * MessageUtil
	 *
	 * author: Yun Jinsang (a.k.a. Wooyaggo, http://www.as3.kr, victim4 at gmail.com)
	 * created: Mar 22, 2010
	 *
	 */
	
	public final class MessageUtil
	{
		static public function replace( $originalText: String, $alias: String, $replace: String ): String
		{
			if( $originalText.charAt( ( $originalText.indexOf( $alias ) + $alias.length ) ) == "|" )
			{
				// Suffix character start index next alias
				var suffixStart: int = $originalText.indexOf( $alias ) + $alias.length + 1;
				// Suffix character end index.
				var suffixEnd: int = $originalText.indexOf( "|", suffixStart + 1 );
				
				// Substring suffix character.
				var suffixGroup: String = $originalText.substring( suffixStart, suffixEnd );
				// Split suffix character to group.
				var suffix: Array = suffixGroup.split( "," );
				
				// Remove suffix from original text.
				$originalText = $originalText.substr( 0, suffixStart - 1 ) + $originalText.substr( suffixEnd + 1, $originalText.length - 1 );
				
				// Change $replace with correct suffix.
				// Determine suffix through HangulUtil.addSuffix.
				$replace = HangulUtil.addSuffix( $replace, suffix[ 0 ], suffix[ 1 ] );
			}
			
			var converted: String = $originalText.replace( $alias, $replace );
			
			return converted;
		}
	}
}